#ifndef __BVHCONSTRUCTOR_H
#define __BVHCONSTRUCTOR_H

#include "Bvh.h"



namespace CHCDemoEngine
{

/** This class represents a bvh construction algorithm
*/
class BvhConstructor
{
public:

	BvhConstructor(SceneEntity **entities, int first, int last);

	/** Constructs a bvh and returns the root and the number of bvh nodes.
	*/
	BvhNode *Construct(int &nodes);


protected:

	int SortTriangles(BvhLeaf *leaf, int axis, float position);

	int SortTrianglesSpatialMedian(BvhLeaf *leaf, int axis);

	BvhNode *SubdivideLeaf(BvhLeaf *leaf, int parentAxis);

	inline bool TerminationCriteriaMet(BvhLeaf *leaf) const;

	void UpdateBoundingBoxes(BvhNode *node);


	/////////////////

	SceneEntity **mEntities;

	int mFirst;
	int mLast;

	int mMaxDepth;
	int mMaxObjects;
	int mNumNodes;
};

}

#endif // __BVH_H